%global	_fwpath	/usr/lib/firmware
%global	nonfree_commit a6ed59a078d52ad72f0f2b99e68f324e7411afa1
%global	nonfree_srcdir	firmware-nonfree-%{nonfree_commit}

Name:		rpi-firmware-nonfree
Version:	20241222
Release:	3%{?dist}
Summary:	Supplemental firmware used by Linux kernel for some Raspberry Pi models
BuildArch:	noarch
ExclusiveArch:	aarch64

License:	binary-redist-Broadcom-wifi
URL:		https://github.com/RPi-Distro/firmware-nonfree

Source0:	https://github.com/RPi-Distro/firmware-nonfree/archive/%{nonfree_commit}/firmware-nonfree-%{nonfree_commit}.tar.gz
Source1:        LICENSE
Requires:	linux-firmware

%description
This package provides suppremental firmware files not included in linux-firmware
package to enable Bluetooth/Wi-Fi on some Raspberry Pi models.

%prep
%setup -n %{nonfree_srcdir}

%build

%install
install -d %{buildroot}%{_fwpath}/brcm
install -d %{buildroot}/usr/share/licenses/brcm
cp %{SOURCE1} %{buildroot}/usr/share/licenses/brcm
cp debian/copyright %{buildroot}/usr/share/licenses/brcm
cp debian/config/brcm80211/brcm/brcmfmac43455-sdio.txt %{buildroot}%{_fwpath}/brcm/
cp debian/config/brcm80211/brcm/brcmfmac43456-sdio.txt %{buildroot}%{_fwpath}/brcm/
cp debian/config/brcm80211/brcm/brcmfmac43456-sdio.bin %{buildroot}%{_fwpath}/brcm/
cp debian/config/brcm80211/brcm/brcmfmac43456-sdio.clm_blob %{buildroot}%{_fwpath}/brcm/

# Other firmware files installed by linux-firmware are compressed, so compress these as well
xz -C crc32 %{buildroot}%{_fwpath}/brcm/brcmfmac43455-sdio.txt
xz -C crc32 %{buildroot}%{_fwpath}/brcm/brcmfmac43456-sdio.bin
xz -C crc32 %{buildroot}%{_fwpath}/brcm/brcmfmac43456-sdio.clm_blob
xz -C crc32 %{buildroot}%{_fwpath}/brcm/brcmfmac43456-sdio.txt

# Pi Zero 2W
ln -s brcmfmac43436s-sdio.txt %{buildroot}%{_fwpath}/brcm/brcmfmac43436s-sdio.raspberrypi,model-zero-2-w.txt
ln -s brcmfmac43430-sdio.raspberrypi,model-zero-w.txt %{buildroot}%{_fwpath}/brcm/brcmfmac43430-sdio.raspberrypi,model-zero-2-w.txt

# Raspberry Pi CM 4
ln -s brcmfmac43455-sdio.bin.xz %{buildroot}%{_fwpath}/brcm/brcmfmac43455-sdio.raspberrypi,4-compute-module.bin.xz
ln -s brcmfmac43455-sdio.clm_blob.xz %{buildroot}%{_fwpath}/brcm/brcmfmac43455-sdio.raspberrypi,4-compute-module.clm_blob.xz
# Raspberry Pi 400
ln -s brcmfmac43456-sdio.bin.xz %{buildroot}%{_fwpath}/brcm/brcmfmac43456-sdio.raspberrypi,400.bin.xz
ln -s brcmfmac43456-sdio.clm_blob.xz %{buildroot}%{_fwpath}/brcm/brcmfmac43456-sdio.raspberrypi,400.clm_blob.xz
ln -s brcmfmac43456-sdio.txt.xz %{buildroot}%{_fwpath}/brcm/brcmfmac43456-sdio.raspberrypi,400.txt.xz

%files
%license /usr/share/licenses/brcm/LICENSE
%license /usr/share/licenses/brcm/copyright
%{_fwpath}/brcm/*


%changelog
* Sun Mar 02 2025 Bryan Zuelly <bzuelly@outlook.com> - 
- Initial
- Based on linux-firmware-raspberry package from Alma Linux
